Subject: Re: bug#59559: 28.1; `minibuffer-with-setup-hook' with :append

From: Eli Zaretskii <[email-masked]>
Date: Sat, 21 Jan 2023 17:35:16 +0200

> Cc: "[email-masked]" <[email-masked]>
> From: Michael Heerdegen <[email-masked]>
> Date: Sat, 21 Jan 2023 15:36:04 +0100
> 
>  (defmacro minibuffer-with-setup-hook (fun &rest body)
>    "Temporarily add FUN to `minibuffer-setup-hook' while executing BODY.
> 
> -By default, FUN is prepended to `minibuffer-setup-hook'.  But if FUN is of
> -the form `(:append FUN1)', FUN1 will be appended to `minibuffer-setup-hook'
> -instead of prepending it.
> +In the default case, FUN is an expression that should evaluate to
> +a function, and the result will be prepended to
> +`minibuffer-setup-hook'.  If FUN is an unquoted list of the
> +form `(:append FUN1)', the result of evaluating FUN1 will be
> +appended to `minibuffer-setup-hook' instead of prepending it.

How about just adding the obvious to the first sentence:

  Temporarily add function FUN to `minibuffer-setup-hook' while executing BODY.

All the rest sounds clear to me, and I find the original text less
confusing than your proposed change ("expression that should evaluate
to a function"?).